%define ast_api_ver 1.8.4
%define bench_ver 1.0.7
%define modname register_license_g729
Summary: G.729 support for Asterisk - The Open Source Linux PBX
Name: asterisk-codec-g729
Version: 3.1.5
Release: 0
License: Proprietary
Group: Applications/Internet
URL: http://downloads.digium.com/pub/telephony/codec_g729/
Source0: http://downloads.digium.com/pub/telephony/codec_g729/asterisk-%{ast_api_ver}/x86-32/codec_g729a-%{ast_api_ver}_%{version}-generic_32.tar.gz
Source1: http://downloads.digium.com/pub/telephony/codec_g729/asterisk-%{ast_api_ver}/x86-64/codec_g729a-%{ast_api_ver}_%{version}-generic_64.tar.gz
Source2: http://downloads.digium.com/pub/telephony/codec_g729/benchg729/x86-32/benchg729-%{bench_ver}-x86_32
Source3: http://downloads.digium.com/pub/telephony/codec_g729/benchg729/x86-64/benchg729-%{bench_ver}-x86_64
Source4: http://downloads.digium.com/pub/register/x86-32/register
Source5: register_license_g729_2.0.0-0.tgz

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

#Requires: asterisk >= %{ast_api_ver}
Requires: asterisk >= 2009020507:1.8.3.3
BuildRequires: asterisk-devel >= 2009020507:1.8.3.3
Prereq: elastix >= 2.0

%description
Asterisk is a complete PBX in software. It runs on Linux and provides
all of the features you would expect from a PBX and more. Asterisk
does voice over IP in three protocols, and can interoperate with
almost all standards-based telephony equipment using relatively
inexpensive hardware.

This module contains the patented G.729 codec support for the Asterisk %{ast_api_ver}
series. It also contains the tools required to license the use of the G.729 
codec in your individual machine. with the use of a license key supplied by 
Digium. In addition, this module contains an Elastix GUI for the registration
process.

%prep
rm -rf codec_g729a-%{ast_api_ver}_%{version}-generic
if [ %{_arch} == "x86_64" ] ; then
	tar -xzf %{SOURCE1}
else
	tar -xzf %{SOURCE0}
fi
mv codec_g729a-%{ast_api_ver}_%{version}-generic_* codec_g729a-%{ast_api_ver}_%{version}-generic
cd codec_g729a-%{ast_api_ver}_%{version}-generic
if [ %{_arch} == "x86_64" ] ; then
	cp %{SOURCE3} benchg729
else
	cp %{SOURCE2} benchg729
fi
cp %{SOURCE4} .

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{_libdir}/asterisk/modules/
mkdir -p %{buildroot}%{_localstatedir}/lib/asterisk/licenses
mkdir -p %{buildroot}%{_docdir}
mkdir -p %{buildroot}%{_docdir}/%{name}-%{version}
cd codec_g729a-%{ast_api_ver}_%{version}-generic
cp benchg729 %{buildroot}%{_sbindir}
cp register %{buildroot}%{_sbindir}/register.g729
cp codec_g729a.so %{buildroot}%{_libdir}/asterisk/modules/
cp LICENSE README %{buildroot}%{_docdir}/%{name}-%{version}/

tar -xzvf %{SOURCE5}
cd %{modname}

# Files provided by all Elastix modules
mkdir -p    $RPM_BUILD_ROOT/var/www/html/
mv modules/ $RPM_BUILD_ROOT/var/www/html/

# Additional (module-specific) files that can be handled by RPM

# The following folder should contain all the data that is required by the installer,
# that cannot be handled by RPM.
mkdir -p    $RPM_BUILD_ROOT/usr/share/elastix/module_installer/%{name}-%{version}-%{release}/
mv setup/   $RPM_BUILD_ROOT/usr/share/elastix/module_installer/%{name}-%{version}-%{release}/
mv menu.xml $RPM_BUILD_ROOT/usr/share/elastix/module_installer/%{name}-%{version}-%{release}/


%post
# Add a line allowing execution by user asterisk to /etc/sudoers
if ! grep -q "register.g729" /etc/sudoers ; then
	echo "Adding register.g729 to /etc/sudoers ..."
	echo "asterisk ALL = NOPASSWD: /usr/sbin/register.g729" >> /etc/sudoers
	chmod 440 /etc/sudoers
fi

# Run installer script to fix up ACLs and add module to Elastix menus.
elastix-menumerge /usr/share/elastix/module_installer/%{name}-%{version}-%{release}/menu.xml

# The installer script expects to be in /tmp/new_module
mkdir -p /tmp/new_module/%{modname}
cp -r /usr/share/elastix/module_installer/%{name}-%{version}-%{release}/* /tmp/new_module/%{modname}/
chown -R asterisk.asterisk /tmp/new_module/%{modname}

#php /tmp/new_module/%{modname}/setup/installer.php
rm -rf /tmp/new_module

%preun
# Remove the register.g729 line from /etc/sudoers
if [ $1 -eq 0 ]; then
	grep -v register.g729 /etc/sudoers > /tmp/sudoers.tmp
	cp /tmp/sudoers.tmp /etc/sudoers
	rm -f /tmp/sudoers.tmp
	chmod 440 /etc/sudoers
	echo "Delete G.729 menus"
	elastix-menuremove "%{modname}"
fi


%files
%defattr(-,root,root,-)
# %doc README LICENSE
%{_docdir}/%{name}-%{version}/*
%{_sbindir}/register.g729
%{_sbindir}/benchg729
%{_libdir}/asterisk/modules/codec_g729a.so
%{_localstatedir}/lib/asterisk/licenses
%defattr(-, asterisk, asterisk)
%{_localstatedir}/www/html/*
/usr/share/elastix/module_installer/*

%changelog
* Mon May  2 2011 Alex Villacis Lasso <a_villacis@palosanto.com> 3.1.5-0
- Rebuild for version 3.1.5 and Asterisk 1.8.3.3

* Mon Jun 21 2010 Alex Villacis Lasso <a_villacis@palosanto.com> 3.1.4-0
- Initial release

